"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class TypeParamInterceptor {
    before(context) {
        const container = context.getContainer();
        const activationInfo = context.getActivation();
        const args = context.getArguments();
        let hasParams = false;
        activationInfo.method.parameters.forEach((param) => {
            if (container && container.isBound(param.type)) {
                hasParams = true;
                args[param.idx] = container.get(param.type);
            }
        });
        if (!hasParams) {
            // Remove this activation from the method's chain
            activationInfo.removeBeforeActivation(this, context);
        }
        return true;
    }
}
exports.TypeParamInterceptor = TypeParamInterceptor;
//# sourceMappingURL=type.param.inject.js.map