"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lib_reflect_1 = require("lib-reflect");
const lodash_1 = require("lodash");
const interceptor_data_1 = require("../interceptor.data");
exports.UseActivation = (activation, type, metadata) => lib_reflect_1.AnyDecoratorFactory((classData, methodOrProp, arg2) => {
    const data = new interceptor_data_1.InterceptorData();
    data.target = activation;
    if (!lodash_1.isNil(type)) {
        data.type = type;
    }
    data.metadata = metadata;
    // Add the information on attributes data
    const decoratorType = lib_reflect_1.GetDecoratorType(classData, methodOrProp, arg2);
    switch (decoratorType) {
        case lib_reflect_1.DecoratorType.Class:
            classData.attributesData.push(data);
            break;
        case lib_reflect_1.DecoratorType.Method:
            methodOrProp.attributesData.push(data);
            break;
        default:
            throw new Error('Invalid usage of the UseActivation decorator.');
    }
});
exports.UseBefore = (activation, metadata) => exports.UseActivation(activation, interceptor_data_1.InterceptorType.Before, metadata);
exports.UseAfter = (activation, metadata) => exports.UseActivation(activation, interceptor_data_1.InterceptorType.After, metadata);
//# sourceMappingURL=use.activation.js.map