"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const activation_result_1 = require("./activation.result");
class DefaultContext {
    constructor(_container, _activation) {
        this._container = _container;
        this._activation = _activation;
        this._result = new activation_result_1.ActivationResult();
        this._data = new Map();
        this._args = null;
    }
    execute() {
        return this._activation.execute(this);
    }
    getActivation() {
        return this._activation;
    }
    getContainer() {
        return this._container;
    }
    getResult() {
        return this._result;
    }
    setResult(res) {
        this._result = res;
    }
    getArguments() {
        return this._args;
    }
    setArguments(args) {
        this._args = args;
    }
    getData(key, defaultVal) {
        if (!this._data.has(key)) {
            return defaultVal;
        }
        return this._data.get(key);
    }
    setData(key, data) {
        this._data.set(key, data);
    }
}
exports.DefaultContext = DefaultContext;
//# sourceMappingURL=context.js.map