"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
var InterceptorType;
(function (InterceptorType) {
    InterceptorType[InterceptorType["Before"] = 1] = "Before";
    InterceptorType[InterceptorType["After"] = 2] = "After";
})(InterceptorType = exports.InterceptorType || (exports.InterceptorType = {}));
class InterceptorData {
    constructor() {
        this.type = InterceptorType.Before | InterceptorType.After;
    }
    createInstance() {
        if (!lodash_1.isNil(this.instance)) {
            return;
        }
        if (lodash_1.isFunction(this.target)) {
            this.instance = Reflect.construct(this.target, []);
        }
        else {
            this.instance = this.target;
        }
    }
}
exports.InterceptorData = InterceptorData;
//# sourceMappingURL=interceptor.data.js.map