import { Container } from 'inversify';
import { ClassData, MethodData } from 'lib-reflect';
import { ActivationResult } from '../activation.result';
import { IAfterActivation } from './i.after.activation';
import { IBeforeActivation } from './i.before.activation';
export declare type ActivationErrorCallback = (interceptor: IBeforeActivation | IAfterActivation, err: any) => void;
export interface IActivation {
    class: ClassData;
    method: MethodData;
    execute(ctx: IContext, onError?: ActivationErrorCallback): Promise<any>;
    removeBeforeActivation(activation: IBeforeActivation, context: IContext): void;
    removeAfterActivation(activation: IAfterActivation, context: IContext): void;
}
export interface IContext {
    execute(): Promise<any>;
    getActivation(): IActivation;
    getContainer(): Container;
    getResult(): ActivationResult;
    setResult(res: ActivationResult): void;
    getArguments(): any[];
    setArguments(args: any[]): void;
    getData<T>(key: string, defaultVal?: T): T;
    setData(key: string, data: any): void;
}
